#!/usr/bin/python3

from utils import *
from download_page import download
from urllib.parse import unquote

# portable code to get filename
import os
platform = os.path.basename(__file__)
if platform.endswith(".py"):
	platform = platform[:(-3)]

def extract_from_page (page, verbosity):
	# it's like %22%2C%22rss_url%22%3A%22https%3A%2F%2Ffeeds.npr.org%2F510310%2Fpodcast.xml%22%2C%22
	# and we have to fix the codes
	feed = search (page, '%22%2C%22rss_url%22%3A%22', '%22%2C%22')
	if not feed is None:
		return unquote(feed)

def extract (url, page=None, network=False, verbosity=3, args={}):
	# cannot get feed from URL alone
	if not network:
		return None

	page = download (platform, url, args, verbosity)
	feed = extract_from_page (page, verbosity)
	if not feed is None:
		return feed
